#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>
#include  <unistd.h>
#include  <getopt.h>
#include  <lo/lo.h>

/* ----------------------------------------------------------------- */

#define	LOCAL_PORT	"9000"
#define	JOY_DEVICE	"/dev/input/js0"

int		verbose = 0;

/* ----------------------------------------------------------------- */
int xy_handler(const char *path, const char *types, lo_arg ** argv,
                int argc, void *data, void *user_data)
{
int	val_x, val_y;

val_x = argv[0]->i;	val_y = argv[1]->i;

printf("%d %d\n", val_x, val_y);
fflush(stdout);
exit(0);

return 0;
}
/* ----------------------------------------------------------------- */
void error(int num, const char *msg, const char *path)
{
fprintf(stderr, "liblo server error %d in path %s : %s\n", num, path, msg);
exit(1);
}
/* ----------------------------------------------------------------- */
static void help(int k)
{
puts("\t* wait for joy          " __DATE__ " *");
puts("\t-j\tjoystick device ("JOY_DEVICE")");
puts("\t-v\tincrease verbosity");


exit(0);
}
/* ----------------------------------------------------------------- */

int main(int argc, char *argv[])
{
int		foo;
lo_server_thread st;
char		*local_port = LOCAL_PORT;
char		*joy_device = JOY_DEVICE;
int		opt;
time_t		debut;

/* parsing command line options */
while ((opt = getopt(argc, argv, "hj:p:v")) != -1) {
	switch (opt) {
		case 'h':	help(0);		break;
		case 'j':	joy_device = optarg;	break;
		case 'p':	local_port = optarg;	break;
		case 'v':	verbose++;		break;
		default:	exit(1);
		}
	}

st = lo_server_thread_new(local_port, error);
lo_server_thread_add_method(st, "/joystick/xy", "ii", xy_handler, NULL);
lo_server_thread_start(st);

for (;;) {
	if (verbose)
		fprintf(stderr, "%s : t = %ld\n", argv[0], time(NULL));
	sleep(100);
	}


return 0;
}
/* ----------------------------------------------------------------- */
